package main

import (
	"fmt"
	"time"
)

// 模拟一个耗时的计算任务
func heavyTask(id int) {
	fmt.Printf("任务 %d 开始执行\n", id)
	time.Sleep(2 * time.Second)
	fmt.Printf("任务 %d 执行完成\n", id)
}

func main() {
	fmt.Println("程序开始...")

	// 启动200个goroutine
	for i := 1; i <= 200; i++ {
		go heavyTask(i)
	}

	// 主线程等待一段时间，确保goroutine有足够时间执行
	// 注意：在实际生产环境中应该使用更好的同步机制
	time.Sleep(3 * time.Second)

	fmt.Println("程序结束...")
}
